#include <iostream>

using namespace std;

class Tokenizer
{
    string source;
    int sourceLength;
    string delimiters;
    int start, finish;
public:
    Tokenizer(string s, string d)
    {
        sourceLength = s.length();
        if(sourceLength==0)
            start = string::npos;
         else
         {
             source = s; setDelimiters(d);
             start = finish = 0;
         }
    }

    void setDelimiters(string d) { delimiters = d;}

    bool getNextToken(string & token)
    {
        if(start==string::npos)
            return false;

        start = source.find_first_not_of(delimiters,finish);
        if(start==string::npos)
            return false;

        finish = source.find_first_of(delimiters,start);
        if(finish==string::npos)
        {
            token = source.substr(start);
            start = string::npos;
        }
        else
        {
            token = source.substr(start,finish-start);
            finish++;
            if(finish>=sourceLength)
                start = string::npos;
        }
        return true;
    }

    bool getNextToken(string & token, string d)
    {
        setDelimiters(d);
        return getNextToken(token);
    }
};

int main()
{
    string test = ";abc,vvvv;xxx.u,,.yyy;";
    Tokenizer t(test,".,:;");
    string tok = "";

    while(t.getNextToken(tok))
        cout << tok<< endl;

    cout << "---------------------\n";
    Tokenizer tt(test,";");
    tt.getNextToken(tok);
    cout << tok<< endl;

    tt.getNextToken(tok,",");
    cout << tok<< endl;

    tt.getNextToken(tok," ");
    cout << tok<< endl;

    return 0;
}
